import Sudoku(solve)

import Control.Parallel
import Control.Parallel.Strategies

import Data.Maybe
import Test.QuickCheck

f = "sudoku17.1000.txt" 
fs = "sudoku17.16000.txt"

main :: IO ()
main = do
    grids <- fmap lines $ readFile fs
    let solutions = map solve grids `using` strat 
    print $ all isJust solutions

strat = evalList (rpar `dot` rdeepseq)
     -- chunk 100 (rpar `dot` rdeepseq) 


chunkList n strat = fmap concat . evalList strat . chunks
  where chunks = 
               takeWhile (not.null)
               . map (take n)
               . iterate (drop n)

-- all strategies should be identity-like:
mprop_strat s arg = arg == (arg `using` s)

prop_chunk n xs = n > 0 ==> mprop_strat (chunkList n rdeepseq) xs
                            where types = xs :: [Int]

